'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = toExist;

var _html = require('../utils/html');

var _html2 = _interopRequireDefault(_html);

var _name = require('../utils/name');

var _name2 = _interopRequireDefault(_name);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function toExist(enzymeWrapper) {
  var pass = enzymeWrapper.exists();

  var contextualInformation = {};

  if (enzymeWrapper.getElements().length) {
    contextualInformation.actual = 'Found Nodes: ' + (0, _html2.default)(enzymeWrapper);
  }

  var nodeName = (0, _name2.default)(enzymeWrapper);

  return {
    pass: pass,
    message: 'Expected "' + nodeName + '" to exist.',
    negatedMessage: 'Expected "' + nodeName + '" not to exist. Instead found ' + enzymeWrapper.getElements().length + ' nodes.',
    contextualInformation: contextualInformation
  };
} /**
   * This source code is licensed under the MIT-style license found in the
   * LICENSE file in the root directory of this source tree. *
   *
   * @providesModule toBePresentAssertion
   * 
   */

module.exports = exports['default'];