'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; /**
                                                                                                                                                                                                                                                                               * This source code is licensed under the MIT-style license found in the
                                                                                                                                                                                                                                                                               * LICENSE file in the root directory of this source tree. *
                                                                                                                                                                                                                                                                               *
                                                                                                                                                                                                                                                                               * @providesModule toHavePropAssertion
                                                                                                                                                                                                                                                                               * 
                                                                                                                                                                                                                                                                               */

var _name = require('../utils/name');

var _name2 = _interopRequireDefault(_name);

var _reduceAssertionObject = require('../utils/reduceAssertionObject');

var _reduceAssertionObject2 = _interopRequireDefault(_reduceAssertionObject);

var _stringify3 = require('../utils/stringify');

var _stringify4 = _interopRequireDefault(_stringify3);

var _single = require('../utils/single');

var _single2 = _interopRequireDefault(_single);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function toHaveProp(enzymeWrapper, propKey, propValue) {
  var props = enzymeWrapper.props();
  var wrapperName = (0, _name2.default)(enzymeWrapper);

  // The API allows to check if a component has a prop in general by dropping the third
  // argument.
  if (propValue === undefined && arguments.length === 2 && (typeof propKey === 'undefined' ? 'undefined' : _typeof(propKey)) !== 'object' && Array.isArray(propKey) === false) {
    return {
      pass: props.hasOwnProperty(propKey),
      message: 'Expected <' + wrapperName + '> to have any value for the prop "' + propKey + '"',
      negatedMessage: 'Expected <' + wrapperName + '> not to receive the prop "' + propKey + '"',
      contextualInformation: {
        actual: 'Actual props: ' + (0, _stringify4.default)(_defineProperty({}, propKey, props[propKey])),
        expected: 'Expected props: ' + (0, _stringify4.default)(_defineProperty({}, propKey, propValue))
      }
    };
  }

  var results = _reduceAssertionObject2.default.call(this, props, propKey, propValue);
  var unmatchedKeys = results.unmatchedKeys.join(', ');
  var contextualInformation = {
    actual: 'Actual props: ' + (0, _stringify4.default)(results.actual),
    expected: 'Expected props: ' + (0, _stringify4.default)(results.expected)
  };

  // error if some prop doesn't exist
  if (results.missingKeys.length) {
    var missingKeys = results.missingKeys.join(', ');
    return {
      pass: false,
      message: 'Expected <' + wrapperName + '}> component to have props "' + missingKeys + '", but it did not.',
      negatedMessage: 'Expected <' + wrapperName + '> component to not have a props "' + missingKeys + '", but it did.',
      contextualInformation: contextualInformation
    };
  }

  return {
    pass: results.pass,
    message: 'Expected <' + wrapperName + '> "' + unmatchedKeys + '" prop values to match but they didn\'t.',
    negatedMessage: 'Expected <' + wrapperName + '> "' + unmatchedKeys + '" prop values not to match, but they did.',
    contextualInformation: contextualInformation
  };
}

exports.default = (0, _single2.default)(toHaveProp);
module.exports = exports['default'];